<?php

namespace Avos\Scaffold;

function auth()
{
	global $AUTH;
	return $AUTH;
}

function denied()
{
    return notfound();

    // switch denied to notfound for people checking urls
	header('HTTP/1.0 503 Permission Denied');
	echo "Permission Denied";
	exit;
}

function notfound()
{
	http_response_code(404);
	echo "Not Found";
	exit;
}

function parsePhpTemplate($template, $args=array(), $return=false)
{
    global $_AVOS;

    if (!file_exists(TEMPLATES_FLAVOR . $template) && !file_exists(TEMPLATES . $template)) {
        if (!empty($_AVOS['page'])) {
            $type = $_AVOS['page']['type'];

            //
            // check for <type>.php e.g: webcams.php or webcam.php
            //

            if (file_exists(TEMPLATES . $type.'.php') && $template != $type.'.php') {
                return parsePhpTemplate($type.'.php', $args, $template);
            }

            //
            // check for <type>Index.php e.g: webcamsIndex.php
            //

            else if (file_exists(TEMPLATES . $type.'Index.php') && $template != $type.'Index.php') {
                return parsePhpTemplate($type.'Index.php', $args, $template);
            }

            //
            // check for <type>sSingle.php e.g: webcamsSingle.php (for [urls] type = webcam)
            //

            else if (file_exists(TEMPLATES . $type.'sSingle.php') && $template != $type.'sSingle.php') {
                return parsePhpTemplate($type.'sSingle.php', $args, $template);
            }
        }

        if ($return) {
            return '';
        }
        else {
            echo "$template doesn't exist";
            exit;
        }
	}

	if ($template == 'rpc.php') {
		return '';
	}

    foreach ($args as $k  => $v) {
        $$k = $v;
    }

	$TOP = "";

	// make some variables more available to the templates
	if (isset($_AVOS['page']['page'])) $page = $_AVOS['page']['page'];
	if (isset($_AVOS['page']['pages'])) $pages = $_AVOS['page']['pages'];
	if (isset($_AVOS['page']['title'])) $title = $_AVOS['page']['title'];
	if (isset($_AVOS['page']['matches'])) $matches = $_AVOS['page']['matches'];

	/*
	foreach ($_AVOS['page']['meta'] as $k => $v) {
		$$k = $v;
	}
	*/

	if (isset($_AVOS['templateVars'])) {
		foreach ($_AVOS['templateVars'] as $k => $v) {
			#echo "setting $k = $v<br>";
			$$k = $v;
		}
	}

    ob_start();
    include($template);
    $html = ob_get_contents();
    ob_end_clean();

    return $html;
}


function parseTemplate($name, $vars=array())
{
    $smarty = new \Smarty();

    $smarty->template_dir = TOP . 'templates';
    $smarty->compile_dir = TOP . 'templates_c';
    $smarty->assign('url', URL);
    $smarty->assign('templates', TOP . 'templates');

	if (is_array($vars)) {
    	foreach ($vars as $k => $v) {
			$smarty->assign($k, $v);
		}
	}

    return $smarty->fetch($name);
}

function getUrlConfig()
{
	global $_AVOS;

	#$config = parse_ini_file(BIN . "config.ini", true);
    $config = $_AVOS['config'];

	foreach ($config as $k1 => $v1) {
	
		$section = array();
	
		foreach ($v1 as $k2 => $v2) {
	
			if (is_array($v2)) {
				foreach ($v2 as $k3 => $v3) {
					if (preg_match('!^[\[\{]\s*(.*?)\s*[\}\]]$!', $v3, $c)) {
						$r = array($k3);
						$t = explode(',', $c[1]);
						foreach ($t as $i => $tt) {
							$r[] = trim($tt);
						}
						
						$config[$k1][$k2][$k3] = $r;
					}
				}
			}
            else {
				if (preg_match('!^[\[\{]\s*(.*?)\s*[\}\]]$!', $v2, $c)) {
					$r = array($k2);
					$t = explode(',', $c[1]);
					foreach ($t as $i => $tt) {
						$r[] = trim($tt);
					}
					
					$config[$k1][$k2] = $r;
				}
			}
		}
	}

	return $config;
}

function decodeUrlConfig()
{
	global $_AVOS;

	$routes = array();
	$config = getUrlConfig();
	$urls = $config['urls'];

	return $urls;
}


//
// this is a bit shitty
//

function shortSiteName($s)
{
    $name = str_replace(
        array('bongacams', 'chaturbate', 'flirt4free', 'stripchat', 'streamray', 'livejasmin', 'streamate', 'soulcams', 'liveflirtin', 'webcams', 'imlive', 'camsoda', 'cherry', 'xcams', 'cam4', 'xlove', 'myfreecams', 'amateur','flirtback'),
        array('bc', 'cb', 'ff', 'sc', 'sr', 'lj', 'sm', 'so', 'lf', 'wc', 'il', 'cs', 'cr', 'xc', 'c4', 'xl', 'mf', 'am', 'fb'),
        strtolower($s)
    );

    return $name;

}

//
// get back to the capitalised sitename whether full lower case version or short version
//

function longSiteName($s)
{
	return expandSiteName($s);
}

function expandSiteName($s)
{
	$map = array(
	'bc' => 'BongaCams',
    'cb' => 'Chaturbate',
    'cs' => 'CamSoda',
    'ff' => 'Flirt4Free',
    'sc' => 'StripChat',
    'sr' => 'Streamray',
    'lj' => 'LiveJasmin',
    'sm' => 'Streamate',
    'il' => 'ImLive',
    'so' => 'SoulCams',
    'cr' => 'Cherry',
    'xc' => 'xCams',
    'c4' => 'Cam4',
    'xl' => 'xLove',
	'mf' => 'MyFreeCams',
	'am' => 'Amateur',
	'fb' => 'FlirtBack',
    'bongacams' => 'BongaCams',
    'chaturbate' => 'Chaturbate',
    'camsoda' => 'CamSoda',
    'flirt4free' => 'Flirt4Free',
    'stripchat' => 'StripChat',
    'streamray' => 'Streamray',
    'livejasmin' => 'LiveJasmin',
    'streamate' => 'Streamate',
    'imlive' => 'ImLive',
    'soulcams' => 'SoulCams',
    'xcams' => 'xCams',
    'cam4' => 'Cam4',
    'xlove' => 'xLove',
    'cherrytv' => 'Cherry',
    'myfreecams' => 'MyFreeCams',
	'amateur' => 'Amateur',
	'flirtback' => 'FlirtBack'
			);

	if (isset($map[$s])) {
		return $map[$s];
	}
	else {
		return $s;
	}
}


function expandGender($s)
{
    $genderMap = array('m' => 'Male', 'f' => 'Female', 'c' => 'Couple', 't' => 'Trans');

    if (!isset($genderMap[$s])) {
        return 'Female';
    }

	return $genderMap[$s];
}

function expandStatus($s)
{
	$map = array('o' => 'Offline', 'a' => 'Away', 'f' => 'Freechat', 'g' => 'Group', 'p' => 'Private');

	if (isset($map[$s])) {
		return $map[$s];
	}
	else {
		return $s;
	}
}

function getCache($k)
{
	global $_AVOS;

	if (isset($_AVOS['cache'][$k])) {
		return $_AVOS['cache'][$k];
	}

	return false;
}

function setCache($k, $v)
{
	$_AVOS['cache'][$k] = $v;
}

function isValidRouteCallback($n)
{
	$valid = array(
        'redirect' => 1, 
		'none' => 1, 
		'rpc' => 1, 
		'webcams' => 1, 
		'webcam' => 1, 
		'videos' => 1, 
		'video' => 1,
		'photos' => 1, 
		'photo' => 1,
		'blogs' => 1, 
		'blog' => 1,
		'escorts' => 1, 
		'escort' => 1,
		'posts' => 1,
		'post' => 1,
		'casino' => 1,
		'promote' => 1, 
		'promot' => 1, 
		'users' => 1
			);

	if (isset($valid[$n])) return true;
	denied();
}

function route($appname, $routes, $return = false)
{
    global $_AVOS;

    \Avos\Utils\profFlag("route()");

    //
    // issue 404 for downloaded images if model is offline and site is specified via hideOfflineImages= in config.ini
    //

    $hideOfflineImages = explode(',', getConfig('webcams', 'hideOfflineImages', ''));

    if (count($hideOfflineImages) > 0) {
        $imagesUrl = getConfig('webcams', 'imagesUrl', '');

        $siteCheck = array_reduce($hideOfflineImages,
            function ($r, $i) {
                $r[$i] = 1;
                return $r;
            }
            , array());

        //
        // check: $imagesUrl$siteName/*/$nickname/$index.webp
        // e.g:   /photos/chaturbate/g/i/r/l/girlsexy/21.webp
        //

        if (preg_match("!(?<path>$imagesUrl(?<site>\w+)/.*/(?<nickname>[\w\_\-]+)/)(.*\-)?(?<image>\d+\.(?<type>webp|jpg))!i", $_SERVER['REQUEST_URI'], $c)) {
            $c['site'] = shortSiteName($c['site']);

            //
            // fetch status of model if we need to
            //

            if (isset($siteCheck[$c['site']])) {
                $chk = \Avos\Database\queryList('SELECT status, id FROM webcams WHERE site=:site AND nickname=:nickname', $c);

                if (empty($chk) || $chk[0] == 'o') {

                    //
                    // model is offline
                    //

                    http_response_code(404);
                    exit;
                }

                $model = \Avos\Redis\getModel($chk[1]);

                if (!empty($model['blocked'])) {
                    if (function_exists('geoip_country_code_by_name')) {

                        //
                        // get the users 2 letter country code and check if the model has it blocked
                        //

                        $userCountry = \geoip_country_code_by_name($_SERVER['HTTP_X_REAL_IP']);

                        if (in_array(strtolower($userCountry), $model['blocked'])) {

                            //
                            // user is blocked
                            //

                            http_response_code(404);
                            exit;
                        }
                    }
                }
            }

            //
            // sanity check
            //

            $_SERVER['REQUEST_URI'] = $c['path'] . $c['image'];

            if (strpos($_SERVER['REQUEST_URI'], '..') || !file_exists(WEB . $_SERVER['REQUEST_URI'])) {
                http_response_code(404);
                exit;
            }

            //
            // display the image
            //

            header("Cache-Control: max-age=2592000");
            $mtime = filemtime(WEB . $_SERVER['REQUEST_URI']);
            $etag  = sprintf('"%s-%s"', $mtime, md5(WEB . $_SERVER['REQUEST_URI']));
            $etagReq = (isset($_SERVER["HTTP_IF_NONE_MATCH"]) ? trim($_SERVER["HTTP_IF_NONE_MATCH"]) : false);
            $modSince = (isset($_SERVER["HTTP_IF_MODIFIED_SINCE"]) ? strtotime($_SERVER["HTTP_IF_MODIFIED_SINCE"]) : false);

            if ((int)$modSince === (int)$mtime && $etag === $etagReq) {
                http_response_code(304);
                exit;
            }

            if ($c['type'] == 'webp' && strpos($_SERVER['HTTP_ACCEPT'], 'image/webp') === false) {

                // for old browsers not supporting webp
                $im = imagecreatefromwebp(WEB . $_SERVER['REQUEST_URI']);
                header('Content-Type: image/jpeg');
                ob_start();
                imagejpeg($im);
                header("Content-Length: " . ob_get_length());
                header("Last-Modified: ". gmdate( "D, d M Y H:i:s", $mtime )." GMT" );
                header("Etag: " . $etag);
                ob_end_flush();
            }
            else {

                header("Content-Type: image/$c[type]");
                header('Content-Length: ' . filesize(WEB . $_SERVER['REQUEST_URI']));
                header("Last-Modified: ". gmdate( "D, d M Y H:i:s", $mtime )." GMT" );
                header("Etag: " . $etag);
                readfile(WEB . $_SERVER['REQUEST_URI']);
            }

            exit;
        }
    }

	//
	// see if we have a matching route
	//
	
	$req = (isset($_SERVER['REQUEST_URI'])) ? $_SERVER['REQUEST_URI'] : '';
	$req = str_replace('?debug', '', $req);
	$req = preg_replace('!\?search=.*!', '', $req);

	//
	// if we have ?q= or ?search= to convert to ?kw=
	//

	if (isset($_GET['q'])) {
		$_GET['kw'] = $_GET['q'];
		unset($_GET['q']);
	}
	elseif (isset($_GET['search'])) {
		$_GET['kw'] = $_GET['search'];
		unset($_GET['search']);
	}


	//
	// append feed.xml to a url like /category/online/
	// append /feed.xml to a url like /category/online/2
	// replace file extension in a url like /my-doc.html
	//

	$isSyndication = false;
	$reqStripped = preg_replace(
				array('!/feed.xml$!', '!.xml$!'),
				array('/', '.html'),
				$req
			);

	if ($req != $reqStripped) {
		$isSyndication = true;
		$req = $reqStripped;
	}

	$path = $req;
	$path = preg_replace('!(\?.*)!', '', $path);
	#$path = preg_replace('!^//?!', '', $path);
	#$path = preg_replace('!^v2/!', '', $path);

	//
	// call the first matching route
	//
	
	$found_route = false;
	#echo "<pre>";
	if (isset($_GET['debug'])) $_AVOS['debug'][] = "request = $req<h3>[urls] searching...</h3>";

	//
	// $r[0] = rule name
	// $r[1] = type
	// $r[2] = path
	// $r[3] = extra args
	//

    foreach ($routes as $r) {

		if (isset($_GET['debug'])) $_AVOS['debug'][] = "$r[0] = $r[2]\n";
		#$re = '!^' . preg_replace(array('!/!', '!:(\w+)!'), array('\\/', '(?P<$1>[\w\-\.]+)'), $r[0]) . '$!';

		$domain = $_SERVER['HTTP_HOST'];
		$subdomain = '';
		if (preg_match('!(.*)?\.(.*\..*)!', $domain, $cap)) {
			$subdomain = $cap[1];
		}

		//
		// first check to see if we have a subdomain defined in the path or fully qualified domain/sub
		//

		if (preg_match('!^(\w+)(/.*)!', $r[2], $cap)) {

			//
			// bare subdomain defined like www/webcams/:page
			//

			if ($cap[1] != $subdomain) {
				if (isset($_GET['debug'])) $_AVOS['debug'][] = "<br>";
				continue;
			}

			$r[2] = $cap[2];
		}
		elseif (preg_match('!^(.*\..*)(/.*)!', $r[2], $cap)) {

			//
			// fully qualified domain name
			//

			if ($cap[1] != $domain) {
				if (isset($_GET['debug'])) $_AVOS['debug'][] = "<br>";
				continue;
			}

			$r[2] = $cap[2];
		}

		//
		// convert the string to match into a regex to match with the requested URI
		//

		if ($r[2][0] != '!') {
			$re = '!^' . preg_replace(array('!/!', '!:(_?[A-Za-z]+)!'), array('\\/', '(?P<$1>([^/]+)?)'), $r[2]) . '$!';
		}

		//
		// if the url rule is already a regex then check against the request 
		// and redirect if matches
		//

		elseif ($r[1] == 'redirect' && preg_match($r[2], $req)) {
			if (isset($_GET['debug'])) $_AVOS['debug'][] = " ... <b>found match</b><br>";
			$r[3] = preg_replace($r[2], $r[3], $path);
            isValidRouteCallback($r[1]);
			$ret = call_user_func('\\' . $appname . '\Routes\\' . $r[1], $r[3], $r[3]);
			return; # can only be a redirect (?)
		}
		else {
			$re = $r[2];
		}

		#$rep = str_replace(array('<', '>'), array('&lt;', '&gt;'), $re);
		#if (isset($_GET['debug'])) $_AVOS['debug'][] = "regex=$rep<br>\n";
	
		if (preg_match($re, $path, $c)) {
            if (isset($_GET['debug'])) $_AVOS['debug'][] = " ... <b>found match</b><br>";

            //
            // if type=webcams and contains either :tag or :category check if it exists
            //

            if ($r[1] == 'webcams') {
                if (isset($c['tag']) && getWebcamsCategory($c['tag'], 'tags') == FALSE) {
                    continue;
                }

                if (isset($c['category']) && getWebcamsCategory($c['category']) == FALSE) {
                    continue;
                }
            }

            //
            // url has matched
            //

			$found_route = true;
			if (!isset($r[3])) $r[3] = '';

			//
			// save matched route for pagination
			//

			if (strpos($r[2], ':page') === false) {
				$_AVOS['page']['route'] = getConfig('templates', 'homePagination', '/');
			}
			else {
				$_AVOS['page']['route'] = $r[2];
			}

			//
			// merge path args with querystring args and convert format into SQL
			// * ignore 'page' and 'sort'
			// * extra args $r3a should override url the url decode $c
			//

            parse_str($r[3], $r3a);

			//
			// add values captures from the path into the extra args, like from /foo/:category/
			//

			foreach ($c as $cname => $cval) {
				if (!is_int($cname) && $cname != 'layout' && $cname != 'page' && $cname != 'sort' && !isset($r3a[$cname])) {
					$r3a[$cname] = $cval;
				}
			}

			//
			// sort=, layout= and count= are moved from filter to args
			//

            foreach (array('sort', 'layout', 'count') as $a) {
                if (isset($r3a[$a])) {
                    $c[$a] = $r3a[$a];
                    unset($r3a[$a]);
                }
            }

			//
			// add values from the query string to either extra args $r3a or captures from the path $c
			//

			foreach ($_GET as $cname => $cval) {
                if (preg_match('!^\w+$!', $cname) && preg_match('!^[\w\.\*\|]+$!', $cval)) {

					if ($cname == 'layout' || $cname == 'page' || $cname == 'sort') {

						//
						// special cases for: page, sort
						// they get added to the $args (unless already set) and not the $filter to the Route callback
						//

						$c[$cname] = $cval;
					}
					else {
                        $r3a[$cname] = $cval;
					}
				}
            }

			//
			// expand any pagination args like in /:site-cams/:page
			//

			$search = array();
			$replace = array();

			foreach ($r3a as $k => $v) {

				if (!empty($v)) {
					// if $v starts with : then expand
					if ($v[0] == ':') {
						$v = ltrim($v, ':');
						$r3a[$k] = $r3a[$v];
						$v = $r3a[$v];
					}

					$search[] = ':' . $k;
					$r3a[$k] = urldecode($v);
					$replace[] = $r3a[$k];

					if (isset($c[$k])) {
						// in case needs urldecoding
						$c[$k] = $r3a[$k];
					}
				}
            }

            //
            // check if any args are seo-nicified allowing urls like ?toys=domi
            // which get mapped to ?kwtoys=domi for searching by keyword
            //

            $queryArgKeywordMap = getConfig('meta', 'queryArgKeywordMap', '');
            $queryArgKeywordHash = [];

            if (!empty($queryArgKeywordMap)) {
                foreach (explode(',', $queryArgKeywordMap) as $k) {
                    $queryArgKeywordHash[$k] = 1;
                }

                foreach ($r3a as $k => $v) {
                    if (isset($queryArgKeywordHash[$k])) {
                        unset($r3a[$k]);
                        $r3a["kw$k"] = $v;
                    }
                }
            }

            \setTemp('queryArgKeywordMap', $queryArgKeywordHash);

			//
			// save all matched page/route info
			//

			$_AVOS['page']['route'] = str_replace($search, $replace, $_AVOS['page']['route']);
			$_AVOS['page']['name'] = $r[0];
			$_AVOS['page']['type'] = $r[1];
			$_AVOS['page']['args'] = $r3a;
            $_AVOS['page']['xml'] = $isSyndication;

            //
            // now the request has been decoded we can log in redis
            //

            if (getConfig('site', 'logRequestsExpiry', 0)) {
                if (!preg_match('!(ico|png|jpg|jpeg|gif|svg|css)$!', $_SERVER['REQUEST_URI']) &&
                    !preg_match('!(AhrefsBot|Amazonbot|applebot|/bing|ClaudeBot|crawler|DataForSeoBot|DotBot|duckduckbot|GoogleBot|gptbot|MJ12bot|petalbot|SemrushBot|YandexBot)!i', $_SERVER['HTTP_USER_AGENT'])) {
                    \Avos\Redis\handle()->rPush(
                        \Avos\Redis\getPrefix('requests'),
                        [
                            time(),
                            function_exists('geoip_country_code_by_name') ? \geoip_country_code_by_name($_SERVER['HTTP_X_REAL_IP']) : '',
                            $_SERVER['REQUEST_URI'],
                            $_AVOS['page']['name'],
                            $_AVOS['page']['type'],
                            $_AVOS['page']['args'],
                            $_SERVER['HTTP_USER_AGENT']
                        ]
                    );
                }
            }

			#print_r($r3a);exit;

			if (isset($_GET['debug'])) {
				foreach ($r3a as $k => $v) {
					$_AVOS['debug'][] = "&nbsp;&nbsp;$k: $v<br>";
				}
			}

            $sql = \Avos\Utils\query2sql($r3a);
            #echo "sql=$sql";exit;
			#echo "c="; print_r($c); echo "<br>r3a="; print_r($r3a); echo "<br>sql=$sql";exit;

			if (isset($c['page']) && !empty($c['page'])) {
				$_AVOS['page']['page'] = $c['page'];
			}
			else {
				$c['page'] = $_AVOS['page']['page'] = 1;
			}

			//
			// for calling via rpc
			//

			$_AVOS['cache']['routeArgs'] = $c;
			$_AVOS['cache']['routeFilter'] = $r3a;

			//
			// call the callback
			//

			#echo "<pre>"; echo "calling \\$appname\\Routes\\$r[1]()\nc = "; print_r($c); echo "args=$sql\n";
            isValidRouteCallback($r[1]);

            //
            // read in any author rules
            //

            readAuthorRules();

			//
			// see if we have tags
			//

			setUrlMeta($r[1], $c[0]);

			//
			// call the route function
			//

			if ($r[1] == 'redirect') {
				$ret = call_user_func('\\' . $appname . '\Routes\\' . $r[1], $c, $r[3]);
			}
			else {
				$fn = '\\' . $appname . '\Routes\\' . $r[1];

				if (function_exists($fn)) {
					$ret = call_user_func($fn, $c, $sql);
				}
				else {
					echo "invalid callback [$r[1]]";
					die();
				}
			}

			//
			// set route return values
			//

			if (isset($ret['args'])) {
				foreach ($ret['args'] as $k => $v) {
					setTemplateValue($k, $v);
				}
			}

			// set url decode
			foreach ($c as $k => $v) {
				if (!is_int($k)) {
					setTemplateValue($k, $v);
				}
			}

			//
			// call user functions if exists with same name as urlconfig rule or
			// template returned by the Route() functions
			//
			// 1st for layout
			//

			$layoutFn = '\\Avos\\User\\layout';

			if (function_exists($layoutFn)) {
                \Avos\Utils\profFlag($layoutFn . '()');
				call_user_func($layoutFn);
			}

			//
			// 2nd template specific
			//

			if (isset($ret['template']) && preg_match('!(.*)\.php!', $ret['template'], $cap)) {
				$userFn = '\\Avos\\User\\' . $cap[1];
			}
			else {
				$userFn = '\\Avos\\User\\' . $r[0];
			}

			if (function_exists($userFn)) {

				// call the function
                \Avos\Utils\profFlag($userFn . '()');
				$ret = call_user_func($userFn, $c, $sql);

				// merge any values set back into $args
				$tvals = getTemplateValues();

				foreach ($tvals as $k => $v) {
					if (!isset($ret['args'][$k])) {
						$ret['args'][$k] = $v;
					}
				}
			}

			if (!isset($ret['template'])) {
				$ret['template'] = $r[0] . '.php';
            }

            $html = '';
	
			if (is_array($ret)) {
				if (isset($ret['args']) && is_array($ret['args'])) {
					$targs = $ret['args'];
				}
				else {
					$targs = array();
				}

				if (isset($ret['type'])) {
					if ($ret['type'] == 'csv') {
						header("Content-type: text/csv");
					}
				}

				if (isset($ret['ftemplate'])) {
					if (preg_match('!\.php$!', $ret['ftemplate'])) {
						$html .= parsePhpTemplate($ret['ftemplate'], $targs, $return);
					}
					else {
						$html .= parseTemplate($ret['ftemplate'], $targs, $return);
					}
				}

				if (isset($ret['template'])) {
					if (isset($c['layout']) && $c['layout'] == 0) {
						$html .= parsePhpTemplate($ret['template'], $targs, $return);
					}
					else {
						$targs['page_contents'] =  parsePhpTemplate($ret['template'], $targs, $return);
						$html .= parsePhpTemplate('layout.php', $targs, $return);
					}
				}
				elseif (isset($ret['html'])) {
					$targs['page_contents'] =  $ret['html'];
					$html .= parsePhpTemplate('layout.php', $targs, $return);
				}
                elseif (isset($ret['redirect'])) {
					header("Location: $ret[redirect]", true, 302);
					return;
				}
			}
			else {
				$html .= $ret;
            }

            //
            // see if we need to return the output or display it
            //

            if ($return) {
                return $html;
            }
            else {
                echo $html;
            }

			return;
		}
		else {
			if (isset($_GET['debug'])) $_AVOS['debug'][] = "<br>";
		}
	}
	
	if (!$found_route && !$return) {
		echo parsePhpTemplate('layout.php', 
			array('page_contents' => parsePhpTemplate('404.php'), [], $return)
		);
		return;
	}
}
	
function setUrlMeta($type, $url)
{
	global $_AVOS;

	if (isset($_GET['debug'])) $_AVOS['debug'][] = "<h3>[meta] searching $type...</h3>";

	$meta = $_AVOS['config']['meta'];
	$_AVOS['page']['meta'] = array();
    $_AVOS['page']['metaRules'] = [];
	$matched = array();

	//
	// merge in meta from external csv file if defined 
	//

    if (isset($_AVOS['config']['meta']['file'])) {

		$file = $_AVOS['config']['meta']['file'];
		$spready = array();

		if (file_exists(TOP . $file)) {

			//
			// convert either xslx or csv to array of arrays
			//

			if (preg_match('!\.xlsx$!i', $file)) {
				if ($xlsx = \SimpleXLSX::parseFile(TOP . $file)) {
					$spready = $xlsx->rows();
				}
				else {
					echo SimpleXLSX::parseError();
				}
			}
	
			else {
				$fh = fopen(TOP . $file, 'r');
				while ($row = fgetcsv($fh)) {
					$spready[] = $row;
				}
				fclose($fh);
			}

			//
			// process header in row 1
			//

			$header = array_shift($spready);
			$cols = array();

			foreach ($header as $i => $h) {
				if (!empty($h)) {
					$cols[$h] = $i;
				}
			}

			//
			// process every other line defining meta values
			//

			if (isset($cols['type']) && isset($cols['path'])) {
				while ($row = array_shift($spready)) {
					if (isset($row[ $cols['type'] ]) && isset($row[ $cols['path'] ])) {
                        $base = $row[ $cols['type'] ] . $row[ $cols['path'] ] . ':';
                        foreach (array_keys($cols) as $k) {
							if ($k != 'type' && $k != 'path' && isset($row[ $cols[$k] ])) {
								$spec = $base . $k;
								$value = $row[ $cols[$k] ];
								if (!empty($value) && empty($meta[$spec])) {
									$meta[$spec] = $value;
								}
							}
						}
					}
				}
			}
		}
    }

	//
	// compare request against meta
	//

    $seen = array();

    $query = $_AVOS['page']['args'];
    #$_AVOS['debug'][] = print_r($query, true) . '<p>';

    $queryExactMatchOnly = getConfig('meta', 'queryExactMatchOnly', false);
    $queryArgKeywordMap = \getTemp('queryArgKeywordMap');

	foreach ($meta as $spec => $opts) {

        $newline = false;

		if (preg_match('!^' . $type . '(.*?)(\?(.+))?:(\w+)$!', $spec, $c)) {
			$matcher = $c[1];
            $matcherQuery = $c[3];
            $meta = $c[4];


            #$_AVOS['debug'][] = "CAPTURE: " . print_r($c,1) . "<br>";
            #$_AVOS['debug'][] = "PATH: $matcher<br>";
            #$_AVOS['debug'][] = "QUERY: $matcherQuery<br>";

            parse_str($matcherQuery, $matcherQuery);
            #$_AVOS['debug'][] = "QUERYA: " . print_r($matcherQuery, 1) . "<br>";

			if (!isset($seen[$type . $matcher])) {
				if (isset($_GET['debug'])) $_AVOS['debug'][] = "$matcher";
				$seen[$type.$matcher] = 1;
				$newline = true;
            }

			if (!isset($_AVOS['page']['meta'][$meta])) {
				$rematcher = str_replace('*', '.*', $matcher);
				$rematcher = str_replace('/', '\\/', $rematcher);
				#echo "checking ($matcher) with ($url)<br>";

				if (preg_match('!^' . $rematcher . '$!', $url)) {
					#if (isset($_GET['debug'])) $_AVOS['debug'][] = "setUrlMeta($matcher) against $url<br>";
					#if (isset($_GET['debug'])) $_AVOS['debug'][] = "setUrlMeta($meta) matched<br>";

                    //
                    // we have matched the requested url path against the path in the meta but need to check query args
                    //

                    $matcherMatched = true;

                    if (count($matcherQuery) > 0) {
                        if ($queryExactMatchOnly && count($matcherQuery) != count($query)) {
                            $matcherMatched = false;
                        }
                        else {
                            foreach ($matcherQuery as $k => $v) {

                                //
                                // first see if we need to expand the kw due to seo-niceness
                                // e.g: toys=domi in the url is mapped to kwtoys=domi 
                                // if queryArgKeywordMap = ethnicity,toys in [meta]
                                //

                                if (isset($queryArgKeywordMap[$k])) {
                                    $k = "kw$k";
                                }

                                if (!isset($query[$k]) || $query[$k] != $v) {
                                    $matcherMatched = false;
                                }
                            }
                        }
                    }

                    //
                    // if we have matched the path and optionally query string then set the meta
                    //

                    if ($matcherMatched) {
                        $matched[$matcher][$meta] = $opts;
                        $_AVOS['page']['meta'][$meta] = $opts;

                        if (!strpos($opts, ':')) {
                            #if (isset($_GET['debug'])) $_AVOS['debug'][] = "setUrlMeta($meta, $opts) final value<br>";
                            setTemplateValue($meta, $opts);
                        }

                        if (isset($_GET['debug']) && $newline) $_AVOS['debug'][] = " ... <b>found match</b>";
                    }
				}
			}

			if (isset($_GET['debug']) && $newline) $_AVOS['debug'][] = "<br>";
		}
	}

    foreach ($matched as $rule => $metas) {
        $_AVOS['page']['metaRules'][] = $rule;

        if (isset($_GET['debug'])) {
			$_AVOS['debug'][] = "<p>";
            $_AVOS['debug'][] = "$rule matched<br>";
			foreach ($metas as $k => $v) {
				$_AVOS['debug'][] = "&nbsp;&nbsp;<b>$k</b> = $v<br>";
			}
			$_AVOS['debug'][] = "</p>";
		}
	}
}

function expandUrlMeta($data = array())
{
	global $_AVOS;

	if (isset($_GET['debug'])) $_AVOS['debug'][] = "<b>final meta:</b><br>";

	if (count($data) == 0) {
		// url was matched but no content found
		// check to see if we have meta for type/404

		$type = $_AVOS['page']['type'];
		$meta = $_AVOS['config']['meta'];

		foreach ($meta as $k => $m) {
			if (preg_match('!^' . $type . '/404:(\w+)!', $k, $c)) {
				$_AVOS['page']['meta'][$c[1]] = $m;
				setTemplateValue($c[1], $m);
			}
		}
		#echo "<pre>";print_r(debug_backtrace());exit;

		return;
	}

	// expand the meta with whatever data we have

	$search = array();
	$replace = array();

	foreach ($data as $k => $v) {
		$search[] = '!:' . $k . '!';
		$replace[] = $v;
	}

	// delete non-scalar
	foreach ($replace as $k => $v) {
		if (is_array($v)) {
			unset($replace[$k]);
		}
    }

	foreach ($_AVOS['page']['meta'] as $k => $v) {
		$tmp = preg_replace($search, $replace, $v);

		if (strpos($tmp, '|') !== false) {
			$arr = explode('|', $tmp);

			$id = $data['id'];
			$choice = $id % count($arr);

			$tmp = $arr[$choice];

			// if it still contains a : then choose the 1st option which needs to not
			if (strpos($tmp, ':') !== false) {
				$tmp = $arr[0];
			}

			// set the final template value
			if (isset($_GET['debug'])) $_AVOS['debug'][] = "&nbsp;&nbsp<b>$k</b> = $tmp<br>";
			setTemplateValue($k, strip_tags($tmp));
		}
		else {
			if (isset($_GET['debug'])) $_AVOS['debug'][] = "&nbsp;&nbsp<b>$k</b> = $tmp<br>";
			setTemplateValue($k, strip_tags($tmp));
		}

		$_AVOS['page']['meta'][$k] = $tmp;
	}

	//
	// set empty values for common meta tags to avoid template php errors
	//

	foreach (array('title', 'keywords', 'description') as $k) {
		if (!isset($_AVOS['page']['meta'][$k])) {
			$_AVOS['page']['meta'][$k] = '';
			setTemplateValue($k, '');
		}
	}

	#if (isset($_GET['debug'])) exit();
}

function customSortCmp($a, $b)
{
	global $custom_sort_field;

	if ($a[$custom_sort_field] == $b[$custom_sort_field]) {
		return 0;
	}

	return ($a[$custom_sort_field] < $b[$custom_sort_field]) ? -1 : 1;
}

function setCustomSortField($field)
{
	global $custom_sort_field;
	$custom_sort_field = $field;
}

function customSort($list, $field='', $reverse=false)
{
	if ($field != '') {
		setCustomSortField($field);
	}

	usort($list, 'customSortCmp');

	if ($reverse) {
		$list = array_reverse($list);
	}

	return $list;
}

function checkBacklink($url)
{
	$html = \file_get_html($url);

	foreach($html->find('a') as $element) {
		#echo rtrim($element->href, '/') . " ==?== http://" . DOMAIN . "<br>";
		if (rtrim($element->href, '/') == 'http://' . DOMAIN) {
			return TRUE;
		}
	}

	return FALSE;
}

function getMimeType($file)
{
    $mimes = [
	    'js' => 'text/javascript',
		'css' => "text/css",
        'htm' => "text/html",
        'html' => "text/html",
        'txt' => "text/plain",
	    'xls' => "application/excel",
		'xlsx' => "application/vnd.openxmlformats",
		'docx' => "application/vnd.openxmlformats",
		'pptx' => "application/vnd.openxmlformats",
		'hqx' => "application/mac-binhex40",
		'bin' => "application/octet-stream",
		'oda' => "application/oda",
		'pdf' => "application/pdf",
		'pgp' => "application/pgp-signature",
		'ps' => "application/postscript",
		'ai' => "application/postscript",
		'eps' => "application/postscript",
		'ppt' => "application/powerpoint",
		'rtf' => "application/rtf",
		'wp5' => "application/wordperfect5.1",
		'wk' => "application/x-123",
		'wz' => "application/x-Wingz",
		'bcpio' => "application/x-bcpio",
		'bz2' => "application/x-bzip2",
		'z' => "application/x-compress",
		'Z' => "application/x-compress",
		'cpio' => "application/x-cpio",
		'csh' => "application/x-csh",
		'deb' => "application/x-debian-package",
		'dvi' => "application/x-dvi",
		'pfa' => "application/x-font",
		'pfb' => "application/x-font",
		'gsf' => "application/x-font",
		'gtar' => "application/x-gtar",
		'tgz' => "application/x-gtar",
		'gz' => "application/x-gzip",
		'hdf' => "application/x-hdf",
		'phtml' => "application/x-httpd-php",
		'pht' => "application/x-httpd-php",
		'php' => "application/x-httpd-php",
		'latex' => "application/x-latex",
		'frm' => "application/x-maker",
		'maker' => "application/x-maker",
		'frame' => "application/x-maker",
		'fm' => "application/x-maker",
		'fb' => "application/x-maker",
		'book' => "application/x-maker",
		'fbdoc' => "application/x-maker",
		'mif' => "application/x-mif",
		'com' => "application/x-msdos-program",
		'exe' => "application/x-msdos-program",
		'bat' => "application/x-msdos-program",
		'nc' => "application/x-netcdf",
		'cdf' => "application/x-netcdf",
		'o' => "application/x-object",
		'pl' => "application/x-perl",
		'pm' => "application/x-perl",
		'pub' => "application/x-mspublisher",
		'sh' => "application/x-sh",
		'shar' => "application/x-shar",
		'sit' => "application/x-stuffit",
		'sv4cpio' => "application/x-sv4cpio",
		'sv4crc' => "application/x-sv4crc",
		'tar' => "application/x-tar",
		'tcl' => "application/x-tcl",
		'tex' => "application/x-tex",
		'pk' => "application/x-tex-pk",
		'PK' => "application/x-tex-pk",
		'texinfo' => "application/x-texinfo",
		'texi' => "application/x-texinfo",
		't' => "application/x-troff",
		'tr' => "application/x-troff",
		'roff' => "application/x-troff",
		'man' => "application/x-troff-man",
		'me' => "application/x-troff-me",
		'ms' => "application/x-troff-ms",
		'ustar' => "application/x-ustar",
		'src' => "application/x-wais-source",
		'zip' => "application/zip",
		'au' => "audio/basic",
		'snd' => "audio/basic",
		'mid' => "audio/midi",
		'midi' => "audio/midi",
		'aif' => "audio/x-aiff",
		'aiff' => "audio/x-aiff",
		'aifc' => "audio/x-aiff",
		'ra' => "audio/x-pn-realaudio",
		'rm' => "audio/x-pn-realaudio",
		'ram' => "audio/x-pn-realaudio",
		'wav' => "audio/x-wav",
		'gif' => "image/gif",
		'ief' => "image/ief",
		'jpeg' => "image/jpeg",
		'jpg' => "image/jpeg",
		'jpe' => "image/jpeg",
		'png' => "image/png",
		'tiff' => "image/tiff",
		'tif' => "image/tiff",
		'ras' => "image/x-cmu-raster",
		'bmp' => "image/x-ms-bmp",
		'BMP' => "image/x-ms-bmp",
		'pnm' => "image/x-portable-anymap",
		'pbm' => "image/x-portable-bitmap",
		'pgm' => "image/x-portable-graymap",
		'ppm' => "image/x-portable-pixmap",
		'rgb' => "image/x-rgb",
		'xbm' => "image/x-xbitmap",
		'xpm' => "image/x-xpixmap",
		'xwd' => "image/x-xwindowdump",
		'tga' => "image/targa",
		'csv' => "text/anytext",
		'txt' => "text/anytext",
		'rtx' => "text/anytext",
		'tsv' => "text/anytext",
		'hpp' => "text/anytext",
		'hxx' => "text/anytext",
		'hh' => "text/anytext",
		'cpp' => "text/anytext",
		'cxx' => "text/anytext",
		'cc' => "text/anytext",
		'h' => "text/anytext",
		'c' => "text/anytext",
		'java' => "text/anytext",
		'moc' => "text/anytext",
		'p' => "text/anytext",
		'pas' => "text/anytext",
		'etx' => "text/anytext",
		'tcl' => "text/anytext",
		'tk' => "text/anytext",
		'tex' => "text/anytext",
		'ltx' => "text/anytext",
		'sty' => "text/anytext",
		'cls' => "text/anytext",
		'vcs' => "text/anytext",
		'vcf' => "text/anytext",
		'csv' => "text/comma-separated-values",
		'txt' => "text/plain",
		'rtx' => "text/richtext",
		'tsv' => "text/tab-separated-values",
		'hpp' => "text/x-c++hdr",
		'hxx' =>  "text/x-c++hdr",
		'hh' => "text/x-c++hdr",
		'cpp' => "text/x-c++src",
		'cxx' => "text/x-c++src",
		'cc' => "text/x-c++src",
		'h' => "text/x-chdr",
		'c' => "text/x-csrc",
		'java' => "text/x-java",
		'moc' => "text/x-moc",
		'p' => "text/x-pascal",
		'pas' => "text/x-pascal",
		'etx' => "text/x-setext",
		'tcl' => "text/x-tcl",
		'tk' => "text/x-tcl",
		'tex' => "text/x-tex",
		'ltx' => "text/x-tex",
		'sty' => "text/x-tex",
		'cls' => "text/x-tex",
		'vcs' => "text/x-vCalendar",
		'vcf' => "text/x-vCard",
		'dl' => "video/dl",
		'fli' => "video/fli",
		'gl' => "video/gl",
		'mpeg' => "video/mpeg",
		'mpg' => "video/mpeg",
		'mpe' => "video/mpeg",
		'qt' => "video/quicktime",
		'flvb' => "video/x-flv",
		'mov' => "video/quicktime",
		'avi' => "video/x-msvideo",
		'movie' => "video/x-sgi-movie",
		'vrm' => "x-world/x-vrml",
		'vrml' => "x-world/x-vrml",
		'wrl' => "x-world/x-vrml",
		'wmv' => "video/x-ms-wmv",
		'doc' => "application/msword",
		'mp3' => "audio/mpeg"
    ];

	$mime = 'unknown/octet-stream';

	if (preg_match('!\.(\w+)$!', $file, $cap)) {
		if (isset($mimes[ $cap[1] ])) {
			$mime = $mimes[ $cap[1] ];
		}
	}

	return $mime;
}

function mungeArray($arr, $col1, $col2)
{
	$ret = array();
	foreach ($arr[ $col1 ] as $i => $elt) {
		if (!empty($arr[ $col2 ][ $i ])) {
			$ret[ $elt ] = $arr[ $col2 ][ $i ];
		}
	}
	return $ret;
}

function readAuthorRules()
{
    global $_AVOS;

    $meta = getConfig('meta');
    $_AVOS['author'] = [];
    $files = [];
    $file = [];
    $rules = [];

    //
    // check for cached data
    //

    foreach ($meta as $k => $v) {
        if (substr($k, 0, 6) == 'author') {
            $files[] = TOP . $v;
        }
    }

    if (($rules = \Avos\Redis\getFiles($files))) {
        $_AVOS['author'] = $rules;
        return;
    }

    //
    // read in each csv file
    //

    foreach ($files as $f) {
        $file = array_merge($file, \Avos\Utils\readSpreadsheet($f));
    }

    //
    // process every row from each csv file
    //

    foreach ($file as $r) {
        if (preg_match('!^[;#]!', $r[0])) {
            continue;
        }

        if (!empty($r[1]) && !empty($r[2])) {

            //
            // must support the following formats:
            //
            // start,title,%checkout% this page
            // start,profile:title,%Site% %Nickname%
            //
            // !isOnline,start,title,%checkout% this page
            // !isOnline,start,profile:title,%Site% %Nickname%
            //
            // rewrite,any,sexy,,sexy,naked,slutty,cute,sweet
            // rewrite,stats,condAdded,%heshe% started %addedOn%
            // rewrite,stats:condAdded,%heshe% started %addedOn%
            //
            // isNew,rewrite,stats,condAdded,%heshe% is a new %model%
            // isNew,rewrite,stats:condAdded,%heshe% is a new %model%
            //

            $startCol = preg_match('!(start|rewrite)!', $r[0]) ? 0 : 1;
            $cond = $startCol ? $r[0] : '';
            $rule = $r[$startCol];

            if ($rule == 'rewrite' && preg_match('!(\w+):(\w+)!', $r[$startCol+1], $c)) {
                $type = $c[1];
                $token = $c[2];
                $valueCol = $startCol+2;
            }
            else {
                $type = $r[$startCol+1];
                $token = $r[$startCol+2];
                $valueCol = $startCol+3;
            }

            $value = isset($r[$valueCol]) ? $r[$valueCol] : '';
            $type = strtolower($type);

            if (isset($_AVOS['authorDebug']) && $_AVOS['authorDebug'] > 1) echo "rule=$rule type=$type token=$token cond=$cond value=$value\n";

            //
            // process a row based on the column definitions
            //

            switch ($rule) {
                case 'start':
                    if (!isset($rules[$rule][$type][$cond])) {
                        $rules[$rule][$type][$cond] = [];
                    }
                    $rules[$rule][$type][$cond][] = $token;
                    break;

                case 'rewrite':
                    $token = strtolower($token);

                    if (!isset($rules[$rule][$type][$cond][$token])) {
                        $rules[$rule][$type][$cond][$token] = [];
                    }

                    $commas = substr_count($value, ",");
                    $dots = substr_count($value, ".");

                    if ($commas > 3 && $commas > $dots) {
                        // assume a single cell contains multiple items
                        $rules[$rule][$type][$cond][$token] = array_merge($rules[$rule][$type][$cond][$token], explode(',', $value));
                    }
                    else {
                        // append a single option
                        for ($i=$valueCol; $i<count($r); $i++) {
                            if (!empty($r[$i])) {
                                $rules[$rule][$type][$cond][$token][] = $r[$i];
                            }
                        }
                    }

                    break;
            }
        }
    }

    //
    // ensure each rule with condition also has at least one with no condition to remove the token from the rule
    // set to '.' to indicate a sentence that can be removed
    //

    $have = ['start' => [], 'rewrite' => ''];

    if (is_array($rules)) {
        foreach ($rules['rewrite'] as $type => $trules) {
            foreach ($trules as $cond => $names) {
                if ($cond) {
                    foreach ($names as $name => $rewrites) {
                        if (!isset($rules['rewrite'][$type][''][$name])) {
                            $rules['rewrite'][$type][''][$name] = ['.'];
                            if (isset($_AVOS['authorDebug']) && $_AVOS['authorDebug'] > 1) echo "> rule=rewrite type=$type token=$name added default\n";
                        }
                    }
                }
            }
        }
    }

    //
    // cache data
    //

    \Avos\Redis\setFiles($files, $rules);
    $_AVOS['author'] = $rules;
}

function checkAuthorCond($m, $e)
{
    if (preg_match('!^[&\w\|\!\(\):]+$!', $e)) {

        //
        // convert: hasTag:mobile|isNew
        // to:      hasTag($m,'mobile')|isNew($m)
        //

        #$e = preg_replace('!(\w+)!', '$1($m)', $e);
        $e = preg_replace('!(\w+):([\w,]+)!', '$1($m,"$2")', $e);
        $e = preg_replace('/(?<!\$)(\b\w+\b)(?![\("])/', '$1($m)', $e);

        $display_errors = ini_get('display_errors');
        $error_reporting = error_reporting();
        ini_set('display_errors', 'Off');
        error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);

        try {
            $rc = eval("namespace Avos\\User\\Author; return $e;");

            ini_set('display_errors', $display_errors);
            error_reporting($error_reporting);

            return $rc;
        }
        catch (\Error $x) {
            #echo "eval error: $e ";
            ini_set('display_errors', $display_errors);
            error_reporting($error_reporting);
            return -2;
        }
    }
    else {
        #echo "parse error: $e ";
        return -1;
    }
}

function checkAllAuthorConds()
{
    global $_AVOS;
    $rules = $_AVOS['author'];

    $models = \Avos\Database\queryAssoc('SELECT id FROM webcams LIMIT 1');
    $model = \extractWebcamsFields([ $models[0]['id'] ])[0];
    $model = getStatsSummary($model['id'], true);

    $nrules = 0;
    $nconds = 0;
    $failed = 0;
    $failures = [];

    foreach ($rules as $startRewrite) {
        foreach ($startRewrite as $names) {
            foreach ($names as $cond => $rules) {
                $nrules++;
                if (!empty($cond)) {
                    $nconds++;
                    echo "$cond ... ";
                    switch (checkAuthorCond($model, $cond)) {

                        case 1:
                        case 0:
                            echo "ok\n";
                            break;

                        case -1:
                            $failed++;
                            echo "err\n";
                            $failures[] = ['error' => 'parse', 'condition' => $cond];
                            break;

                        case -2:
                            $failed++;
                            echo "err\n";
                            $failures[] = ['error' => 'eval', 'condition' => $cond];
                            break;
                    }
                }
            }
        }
    }

    return ['rules' => $nrules, 'conditions' => $nconds, 'failed' => $failed, 'failures' => $failures];
}

function authorRandom($data, $rules, $kw=false)
{
    $valid = [];

    //
    // start rules
    //

    if (!$kw) {
        foreach ($rules as $cond => $rewrites) {
            if ($cond) {
                $words = str_word_count($cond);
                $chk = checkAuthorCond($data, $cond);
                if ($chk > 0) {
                    foreach ($rewrites as $r) {
                        for ($i=0; $i<$words*10; $i++) {
                            $valid[] = $r;
                        }
                    }
                }
            }
        }

        //
        // if no match then check for rules without conditions
        //

        if (count($valid) == 0) {
            foreach ($rules as $cond => $rewrites) {
                if (!$cond) {
                    foreach ($rewrites as $r) {
                        $valid[] = $r;
                    }
                }
            }
        }
    }

    //
    // rewrite rules
    //

    else {
        foreach ($rules as $cond => $rewrites) {

            if ($cond && isset($rules[$cond][$kw])) {
                $words = str_word_count($cond);
                $chk = checkAuthorCond($data, $cond);
                if ($chk > 0) {
                    foreach ($rules[$cond][$kw] as $r) {
                        for ($i=0; $i<$words*10; $i++) {
                            $valid[] = $r;
                        }
                    }
                }
            }
        }

        if (count($valid) == 0) {

            if (isset($rules[''][$kw])) {
                foreach ($rules[''][$kw] as $r) {
                    $valid[] = $r;
                }
            }
        }
    }

    if (count($valid)) {
        return $valid[ mt_rand(0, count($valid)-1) ];
    }
    else {
        return '';
    }
}

function author($type, $data=[], $count=1, $seed=false)
{
    if (!$seed && isset($data['id'])) {
        $seed = $data['id'] + getConfig('templates', 'authorOffset', 0);
    }

    if ($seed) {
        mt_srand($seed);
    }

    //
    // a single author rewrite
    //

    if ($count == 1) {
        return authorRewrite($type, $data);
    }

    //
    // return an array of rewrites
    //

    $r = [];

    for ($i=0; $i<$count; $i++) {
        $t = authorRewrite($type, $data);

        if (!empty($t)) {
            $r[] = $t;
        }
    }

    return $r;
}

function authorRewrite($type, $data)
{
    global $_AVOS;
    $rules = $_AVOS['author'];
    $debug = isset($_AVOS['authorDebug']) ? $_AVOS['authorDebug'] : 0;

    //
    // add in gender specific data
    //

    foreach (genderTransform($data) as $k => $v) {
        $data[$k] = $v;
    }

    //
    // find starting rule
    //

    if (isset($rules['start'][$type][''])) {
        $rule = authorRandom($data, $rules['start'][$type]);
    }
    else {
        return '';
    }

    setTemp('authorRule', $rule);

    //
    // if start token contains a type:name then save
    //

    if (preg_match('!(\w+):(\w+)!', $type, $c)) {
        $startClass = $c[1];
        $startToken = $c[2];
    }
    else {
        $startClass = '';
        $startToken = $type;
    }

    if ($debug) echo "startClass=$startClass startToken=$startToken rule=$rule\n";

    //
    // a type like stats:start should result in 2 possible types that we can append the token name to
    // * stats:start
    // * stats
    //
    // so we search for values like:
    // * stats:start:thing
    // * stats:thing
    // * any:thing
    //

    if (preg_match('!(\w+):(\w+)!', $type, $c)) {
        $types = [ $type, $c[1], 'any' ];
    }
    else {
        $types = [ $type, 'any' ];
    }

    //
    // add in lowercase versions
    //

    foreach ($data as $k => $v) {
        if (is_array($v)) {
            if (count($v) > 0 && isset($v[0])) {
                // choose random one
                $data[$k] = $v[ mt_rand(0, count($v)-1) ];
                $data[strtolower($k)] = $data[$k];
            }
            else {
                unset($data[$k]);
            }
        }
        else {
            $data[strtolower($k)] = $v;
        }
    }

    //
    // add in keys without colon, ie: for 'category:keywords' dupe to 'keywords'
    // what we already have rules defined for 'stats' when parsing 'profile:stats'?
    //
    // redundant code?
    //

    foreach ($rules['rewrite'] as $k => $v) {
        if (preg_match('!\w+:(\w+)!', $k, $c)) {
            if (isset($rules['rewrite'][$k][''])) {
                $rules['rewrite'][$c[1]][''] = $rules['rewrite'][$k][''];
            }
        }
    }

    //
    // iterate until we have no %key% instances left
    //

    while (preg_match('!(%([\w:\!\|]+)%)!', $rule, $c)) {

        $pattern = $c[1];
        $replace = '';

        //
        // handle stream of alternative tokens ala %location|subject|berezka.%
        //

        foreach (explode('|', $c[2]) as $kw) {
            if (empty($replace)) {

                $modifier = '';

                //
                // check for modifier like :days
                //

                if (preg_match('!^(\w+)\!(\w+)$!', $kw, $c)) {
                    $kw = $c[1];
                    $modifier = $c[2];
                }

                $kwk = strtolower($kw);
                $upper = $kw[0] != $kwk[0];

                if ($debug) echo "pattern=$pattern kw=$kw kwk=$kwk upper=$upper\n";

                //
                // special case if the keyword is a models (or other) field
                //

                if (isset($data[$kwk])) {
                    if ($debug) echo "  data[$kwk] = $data[$kwk]\n";

                    //
                    // if data is set then use it
                    //

                    if (!empty($data[$kwk])) {
                        if ($debug) echo "  !empty(\$data[\$kwk]) data[$kwk] = $data[$kwk] replace=$replace\n";
                        $replace = $data[$kwk];
                    }

                    //
                    // treat default keyword as literal if ends in a period
                    //

                    /*
                    else if (!empty($dkwk)) {
                        if ($debug) echo "  !empty(\$kwk) data[$kwk] = $data[$kwk] replace=$replace\n";
                        if (isset($data[$dkwk]) && !empty($data[$dkwk])) {
                            $replace = $data[$dkwk];
                        }
                        else if (substr($dkwk, -1) == '.') {
                            $replace = rtrim($dkwk, '.');
                            $kwlist = [$kwk];
                        }

                        if (empty($replace)) {
                            $replace = $dkwk;
                        }
                    }
                    */

                    else {
                        //
                        // here we have a token like %privateLongest% which has a zero value so append <missing>
                        // so its not removed and signifies the sentence can be deleted if multiple sentences
                        //

                        $replace = $data[$kwk];
                        if (empty($replace)) {
                            $replace .= '<missing>';
                        }
                    }

                    if ($debug) echo "    replace=$replace\n";
                }

                //
                // replacement not found from provided data so try and rewrite the token
                //

                if (empty($replace)) {

                    $kwlist = [];

                    if (preg_match('!(\w+):(\w+)!', $kwk, $cc)) {
                        $tokenClass = $cc[1];
                        $kwk = $cc[2];
                        $kwlist[] = [$tokenClass, $kwk];
                    }

                    if ($startClass) {
                        $kwlist[] = [$startClass, $kwk];
                    }

                    $kwlist[] = ['any', $kwk];

                    foreach ($kwlist as $kw) {
                        if (!$replace) {
                            if ($debug) echo " checking type=$kw[0] kw=$kw[1] replace=$replace\n";
                            if (isset($rules['rewrite'][$kw[0]]) && ($replace = authorRandom($data, $rules['rewrite'][$kw[0]], $kw[1]))) {
                                break;
                            }
                        }
                    }
                }
            }
        }

        if (!$replace) {
            if ($kwk[-1] == '.') {
                $replace = rtrim($kwk, '.');
            }
            else {
                $replace = "$kwk<missing>";
            }
        }

        if ($debug) echo "  replace=$replace\n";

        //
        // check if we have a modifier 
        //

        if (is_numeric($replace) || $replace == '<missing>') {

            //
            // if a timestamp convert to relative number
            //

            switch ($kwk) {
                case 'addedon':
                case 'updatedon':
                    $replace = time() - $replace;
                    break;
            }

            if ($modifier) {

                //
                // missing data but have a modifier
                //

                if ($replace == '<missing>') {
                    $replace = 0;
                }

                //
                // convert seconds to something else
                //

                switch ($modifier) {
                    case 'mins':
                    case 'minutes':
                        $replace = round($replace / 60);
                        break;
                    case 'hrs':
                    case 'hours':
                        $replace = round((int)$replace / 3600, 1);
                        break;
                    case 'days':
                        $replace = round($replace / 86400);
                        break;
                    case 'weeks':
                        $replace = round($replace / 604800, 1);
                        break;
                    case 'months':
                        $replace = round($replace / 2592000, 1);
                        break;
                    case 'years':
                        $replace = round($replace / 31536000, 1);
                        break;
                }

                //
                // if zero prevent from being removed if single sentence rewrite
                // and indicates the whole sentence can be deleted if multiple
                //

                if ($replace == 0) {
                    $replace .= '<missing>';
                }
            }
            else {
                //
                // if a datetime but no modifier then select something sensible
                //

                if (preg_match('!(time|on|longest|avg)(day|month)?!i', $kwk)) {
                    $ago = '';
                    if (substr($kwk, -2) == 'on') {
                        $ago = " ago";
                    }

                    switch ($replace) {
                        case ($replace > 31536000):
                            $replace = round($replace / 31536000, 1) . " years$ago";
                            break;
                        case ($replace > 2592000):
                            $replace = round($replace / 2592000, 1) . " months$ago";
                            break;
                        case ($replace > 604800):
                            $replace = round($replace / 1209600, 1) . " weeks$ago";
                            break;
                        case ($replace > 86400):
                            $replace = round($replace / 172800) . " days$ago";
                            break;
                        case ($replace > 3600):
                            $replace = round($replace / 7200, 1) . " hours$ago";
                            break;
                        case ($replace > 60):
                            $replace = round($replace / 60) . " minutes$ago";
                            break;
                        default:
                            $replace .= " seconds$ago";
                    }
                }
            }
        }

        if ($debug) echo "  replace=$replace\n";

        if ($upper) {
            $replace = ucfirst($replace);
        }

        # this fails when we have a default, could escape the "|"
        #$rule = preg_replace('!' . $pattern . '!', $replace, $rule, 1);

        if (($pos = strpos($rule, $pattern)) !== false) {
            $rule = substr_replace($rule, $replace, $pos, strlen($pattern));
        }
    }

    //
    // remove <missing> sentences from multiple sentence phrase
    //

    setTemp('authorRewrite', $rule);

    if (\Avos\Utils\is_sentences($rule)) {
        $r = [];
        foreach (\Avos\Utils\split_sentences($rule) as $s) {
            if (!strstr($s, '<missing>')) {
                $r[] = $s;
            }
        }

        $rule = implode(' ', $r);
    }

    // remove multiple subsequent occurrences of same word
    $rule = preg_replace('!(\w\w\w+)(\s+\1)+!i', '\1', $rule);

    // <empty> and <missing> are tokens needing to be removed
    $rule = str_replace(['<empty>', '<missing>'], '', $rule);

    // trim whitespace and multiple decimals
    #$rule = preg_replace('!\.([\s\.])*(\s)?!', '.$2', $rule);
    #$rule = preg_replace('!\.([^\d]\w)!', '. $1', $rule);
    $rule = preg_replace('!(([\!\.])\s+)+!', '$1 ', $rule);
    $rule = preg_replace('!\s+!', ' ', $rule);
    $rule = trim($rule, '. ');

    setTemp('authorFinal', $rule);
    return $rule;
}


////////////////////////////////////////////////////////////////////////
// the original author() functions before adding in conditions
////////////////////////////////////////////////////////////////////////

function authorClassic($type, $data=[], $count=1, $seed=false)
{
    if ($count == 1) {
        return authorAux($type, $data, $count, $seed);
    }

    $r = [];

    for ($i=0; $i<$count; $i++) {
        $t = authorAux($type, $data, $count, $seed);

        if (!empty($t)) {
            $r[] = $t;
        }

        $seed = false;
    }

    return $r;
}

function authorAux($type, $data, $count=1, $seed=false)
{
    global $_AVOS;
    $rules = $_AVOS['author'];

    if ($seed) {
        #echo "authorAux() mt_srand($seed)\n";
        mt_srand($seed);
    }

    //
    // add in gender specific data
    //

    if (isset($data['gender'])) {
        switch ($data['gender']) {
            case 'Female':
                $data['heshe'] = 'she';
                $data['hisher'] = 'her';
                $data['himher'] = 'her';
                $data['girlguy'] = 'girl';
                $data['girlguy'] = 'girl';
                break;

            case 'Male':
                $data['heshe'] = 'he';
                $data['himher'] = 'him';
                $data['hisher'] = 'his';
                $data['girlguy'] = 'guy';
                break;

            case 'Trans':
                $data['heshe'] = 'zie';
                $data['hisher'] = 'zir';
                $data['himher'] = 'zim';
                $data['girlguy'] = 'trans';
                break;

            case 'Couple':
                $data['heshe'] = 'they';
                $data['hisher'] = 'her';
                $data['himher'] = 'them';
                $data['girlguy'] = 'couple';
        }
    }

    //
    // find starting rule
    //

    if (isset($rules['start'][$type])) {
        #print_r($rules['start'][$type]['']);
        #echo "mt_rand(0, " . (count($rules['start'][$type][''])-1) . ")\n";
        $rule = $rules['start'][$type][''][ mt_rand(0, count($rules['start'][$type][''])-1) ];
    }
    else {
        return '';
    }

    #echo "authorAux() start=$rule\n";

    //
    // add in captialised versions
    //

    foreach ($data as $k => $v) {
        if (is_array($v)) {
            if (count($v) > 0 && isset($v[0])) {
                // choose random on
                #echo "mt_rand(0, " . (count($v)-1) . ")\n";
                $data[$k] = $v[ mt_rand(0, count($v)-1) ];
            }
            else {
                unset($data[$k]);
            }
        }
        else {
            $data[ucfirst($k)] = ucfirst($v);
        }
    }

    //
    // add in keys without colon, ie: for 'category:keywords' dupe to 'keywords'
    //

    foreach ($rules['rewrite'] as $k => $v) {
        if (preg_match('!\w+:(\w+)!', $k, $c)) {
            $rules['rewrite'][$c[1]] = $rules['rewrite'][$k];
        }
    }

    //
    // iterate until we have no %key% instances left
    //

    while (preg_match('!(%([\w:]+)%)!', $rule, $c)) {

        $pattern = $c[1];
        $kw = $c[2];
        $kwk = strtolower($kw);
        $upper = $kw != $kwk;
        #echo "pattern=$pattern kwk=$kwk\n";

        if (isset($data[$kwk])) {
            $replace = $data[$kwk];
        }
        elseif (isset($rules['rewrite'][$type][''][$kwk])) {
            #echo "case 1 $type $kwk\n";
            #echo "case 1 choices = " . implode(',',$rules['rewrite'][$type][''][$kwk]) . "\n";
            $replace = $rules['rewrite'][$type][''][$kwk][ mt_rand(0, count($rules['rewrite'][$type][''][$kwk])-1) ];
            #echo "case 1 > $replace\n";
            unset($rules['rewrite'][$type][''][$kwk][ $replace ]);

        }
        elseif (isset($rules['rewrite'][$type]['']['any'])) {
            #echo "case 2 $type any\n";
            #echo "case 2 choices = " . implode(',',$rules['rewrite'][$type]['']['any']) . "\n";
            $replace = $rules['rewrite'][$type]['']['any'][ mt_rand(0, count($rules['rewrite'][$type]['']['any'])-1) ];
            #echo "case 2 > $replace\n";
            unset($rules['rewrite']['any'][''][$kwk][ $replace ]);
        }
        elseif (isset($rules['rewrite']['any'][''][$kwk])) {
            #echo "case 3 any $kwk\n";
            #echo "case 3 choices = " . implode(',',$rules['rewrite']['any'][''][$kwk]) . "\n";
            #echo "mt_rand(0, " . (count($rules['rewrite']['any'][''][$kwk])-1) . ")\n";
            $replace = $rules['rewrite']['any'][''][$kwk][ mt_rand(0, count($rules['rewrite']['any'][''][$kwk])-1) ];
            #echo "case 3 > $replace\n";
            unset($rules['rewrite']['any'][''][$kwk][ $replace ]);
            #echo "unset(\$rules['rewrite']['any'][''][ $kwk ][ $replace ]);\n";
        }
        else {
            $replace = '';
        }

        if ($upper) {
            $replace = ucfirst($replace);
        }

        $rule = preg_replace('!' . $pattern . '!', $replace, $rule, 1);
    }

    // remove multiple subsequent occurrences of same word
    $rule = preg_replace('!(\w\w\w+)(\s+\1)+!i', '\1', $rule);

    // EMPTY is a tag needing to be removed
    $rule = str_replace('<empty>', '', $rule);

    // trim whitespace
    $rule = preg_replace('!\s+!', ' ', $rule);
    $rule = preg_replace('!^\s+!', '', $rule);

    return $rule;
}

