/*M!999999\- enable the sandbox mode */ 
-- MariaDB dump 10.19  Distrib 10.5.28-MariaDB, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: avos
-- ------------------------------------------------------
-- Server version	10.5.28-MariaDB-0+deb11u1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `ArticleBlogPosts`
--

DROP TABLE IF EXISTS `ArticleBlogPosts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `ArticleBlogPosts` (
  `Title` varchar(255) NOT NULL,
  `Category` varchar(50) DEFAULT NULL,
  `Tags` varchar(255) DEFAULT NULL,
  `blogkeywords` varchar(256) NOT NULL DEFAULT '',
  `Description` text DEFAULT NULL,
  `Authors` varchar(255) DEFAULT NULL,
  `CreationDate` datetime DEFAULT NULL,
  `MainImage` varchar(255) DEFAULT NULL,
  `Content` longtext DEFAULT NULL,
  `ModelName` varchar(255) DEFAULT NULL,
  `ModelSites` varchar(255) DEFAULT NULL,
  `ContentType` varchar(50) DEFAULT NULL,
  `ImagePathAvatar` varchar(255) DEFAULT NULL,
  `GalleryImages` varchar(255) DEFAULT NULL,
  `publishedOn` datetime DEFAULT NULL,
  `LastUpdated` datetime DEFAULT NULL,
  `urlTitle` varchar(64) DEFAULT NULL,
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `authorssescription` text DEFAULT NULL,
  `Views` int(11) DEFAULT 0,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `cache`
--

DROP TABLE IF EXISTS `cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `cache` (
  `name` varchar(32) NOT NULL,
  `value` longtext NOT NULL,
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dailyStats`
--

DROP TABLE IF EXISTS `dailyStats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `dailyStats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `webcamsId` int(10) unsigned NOT NULL,
  `day` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `month` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `year` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `awayTime` smallint(5) unsigned NOT NULL DEFAULT 0,
  `awaySessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `awayTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  `freechatTime` smallint(5) unsigned NOT NULL DEFAULT 0,
  `freechatSessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `freechatTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  `groupTime` smallint(5) unsigned NOT NULL DEFAULT 0,
  `groupSessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `groupTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  `privateTime` smallint(5) unsigned NOT NULL DEFAULT 0,
  `privateSessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `privateTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `year_month_day_webcamsId_idx` (`year`,`month`,`day`,`webcamsId`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `friendships`
--

DROP TABLE IF EXISTS `friendships`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `friendships` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `friend_id` int(11) NOT NULL,
  `status` enum('pending','accepted','rejected') NOT NULL DEFAULT 'pending',
  `created_at` timestamp NOT NULL DEFAULT current_timestamp(),
  `updated_at` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `history`
--

DROP TABLE IF EXISTS `history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `history` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `webcamsId` int(10) unsigned NOT NULL,
  `epochTime` int(11) unsigned NOT NULL DEFAULT 0,
  `status` enum('o','a','f','g','p') NOT NULL DEFAULT 'f',
  `statusTime` int(10) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `webcamsId_statusTime_idx` (`webcamsId`,`statusTime`),
  KEY `webcamsId_idx` (`webcamsId`),
  KEY `processed_statusTime_idx` (`statusTime`),
  KEY `webcamsId_epochTime_idx` (`webcamsId`,`epochTime`),
  KEY `statusTime_idx` (`statusTime`)
) ENGINE=InnoDB AUTO_INCREMENT=734010507 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `likes`
--

DROP TABLE IF EXISTS `likes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `likes` (
  `id` int(5) NOT NULL AUTO_INCREMENT,
  `pid` int(10) NOT NULL,
  `like` int(10) NOT NULL,
  `unlike` int(10) NOT NULL,
  `uid` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `member`
--

DROP TABLE IF EXISTS `member`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `member` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `username` varchar(255) NOT NULL,
  `nickname` varchar(255) DEFAULT NULL,
  `type` varchar(255) NOT NULL,
  `password` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `useravatar` varchar(255) DEFAULT NULL,
  `modelname` varchar(255) DEFAULT NULL,
  `modelimage` varchar(255) DEFAULT NULL,
  `modelavatar` varchar(255) DEFAULT NULL,
  `modelgalleryimages` varchar(255) DEFAULT NULL,
  `social` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_bin DEFAULT NULL CHECK (json_valid(`social`)),
  `attributes` longtext CHARACTER SET utf8mb4 COLLATE utf8mb4_bin DEFAULT NULL CHECK (json_valid(`attributes`)),
  `full_name` varchar(255) DEFAULT NULL,
  `birthdate` date DEFAULT NULL,
  `website` varchar(255) DEFAULT NULL,
  `hometown` varchar(50) DEFAULT NULL,
  `city` varchar(50) DEFAULT NULL,
  `country` char(2) DEFAULT NULL,
  `job` varchar(50) DEFAULT NULL,
  `company` varchar(50) DEFAULT NULL,
  `school` varchar(50) DEFAULT NULL,
  `about_me` text DEFAULT NULL,
  `interests` text DEFAULT NULL,
  `fav_movies` text DEFAULT NULL,
  `fav_music` text DEFAULT NULL,
  `fav_books` text DEFAULT NULL,
  `turnons` text DEFAULT NULL,
  `turnoffs` text DEFAULT NULL,
  `gender` varchar(255) DEFAULT NULL,
  `age` varchar(255) DEFAULT NULL,
  `orientation` varchar(255) DEFAULT NULL,
  `coverimage` varchar(255) DEFAULT NULL,
  `start_day` varchar(20) DEFAULT NULL,
  `end_day` varchar(20) DEFAULT NULL,
  `start_time` time DEFAULT NULL,
  `end_time` time DEFAULT NULL,
  `relation_status` varchar(255) DEFAULT NULL,
  `selected_websites` varchar(255) DEFAULT NULL,
  `reset_token` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=93 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `monthlyStats`
--

DROP TABLE IF EXISTS `monthlyStats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `monthlyStats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `webcamsId` int(10) unsigned NOT NULL,
  `day` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `month` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `year` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `awayTime` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `awaySessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `awayTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  `freechatTime` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `freechatSessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `freechatTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  `groupTime` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `groupSessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `groupTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  `privateTime` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `privateSessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `privateTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `year_month_webcamsId_idx` (`year`,`month`,`webcamsId`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `photos`
--

DROP TABLE IF EXISTS `photos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `photos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `views` smallint(5) unsigned NOT NULL DEFAULT 0,
  `title` varchar(64) DEFAULT NULL,
  `urlTitle` varchar(64) NOT NULL DEFAULT '',
  `tags` varchar(3070) NOT NULL DEFAULT '',
  `description` varchar(2048) NOT NULL DEFAULT '',
  `origFilename` varchar(128) NOT NULL DEFAULT '',
  `folder` varchar(128) NOT NULL DEFAULT '',
  `addedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `publishedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `viewedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `numPhotos` smallint(5) unsigned NOT NULL DEFAULT 1,
  `mainPhoto` smallint(5) unsigned NOT NULL DEFAULT 1,
  `post_by` varchar(50) DEFAULT NULL,
  `post_date` date DEFAULT NULL,
  `short_description` varchar(255) DEFAULT NULL,
  `categories` varchar(50) DEFAULT NULL,
  `website_model` varchar(50) DEFAULT NULL,
  `photokeywords` varchar(256) NOT NULL DEFAULT '',
  `meta_photos_id` int(10) unsigned DEFAULT NULL,
  `meta_title` varchar(128) DEFAULT NULL,
  `meta_description` varchar(2048) DEFAULT NULL,
  `meta_keywords` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `publishedOn_idx` (`publishedOn`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `photosActions`
--

DROP TABLE IF EXISTS `photosActions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `photosActions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `photosId` int(10) unsigned NOT NULL,
  `action` enum('rename','delete') NOT NULL,
  `info` varchar(128) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=32 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `photosTags`
--

DROP TABLE IF EXISTS `photosTags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `photosTags` (
  `keep` tinyint(1) NOT NULL DEFAULT 1,
  `name` varchar(60) NOT NULL,
  `photosId` int(10) unsigned NOT NULL,
  KEY `name_idx` (`name`),
  KEY `name_webcamsId_idx` (`name`,`photosId`),
  KEY `keep_name_idx` (`keep`,`name`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `posts`
--

DROP TABLE IF EXISTS `posts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `posts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `views` smallint(5) unsigned NOT NULL DEFAULT 0,
  `title` varchar(64) NOT NULL,
  `urlTitle` varchar(64) NOT NULL DEFAULT '',
  `tags` varchar(256) NOT NULL DEFAULT '',
  `body` text NOT NULL DEFAULT '',
  `addedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `publishedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `viewedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `mainPhoto` varchar(128) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `publishedOn` (`publishedOn`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `postsTags`
--

DROP TABLE IF EXISTS `postsTags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `postsTags` (
  `keep` tinyint(1) NOT NULL DEFAULT 1,
  `name` varchar(12) NOT NULL,
  `postsId` int(10) unsigned NOT NULL,
  KEY `keep` (`keep`),
  KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `promote`
--

DROP TABLE IF EXISTS `promote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `promote` (
  `siteId` int(11) NOT NULL AUTO_INCREMENT,
  `siteNames` varchar(255) DEFAULT NULL,
  `siteType` varchar(255) DEFAULT NULL,
  `SiteImage` varchar(255) DEFAULT NULL,
  `SiteLink` varchar(255) DEFAULT NULL,
  `SiteAddon` varchar(255) DEFAULT NULL,
  `SiteOnwer` varchar(255) DEFAULT NULL,
  `sitesDescription` text DEFAULT NULL,
  `publishedOn` datetime DEFAULT NULL,
  `tags` text DEFAULT NULL,
  `pros` text DEFAULT NULL,
  `cons` text DEFAULT NULL,
  `keywords` text DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` text DEFAULT NULL,
  PRIMARY KEY (`siteId`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `promoteMainDescription`
--

DROP TABLE IF EXISTS `promoteMainDescription`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `promoteMainDescription` (
  `mainDescription` text DEFAULT NULL,
  `mainTitle` varchar(255) DEFAULT NULL,
  `mainId` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) DEFAULT NULL,
  `description` text DEFAULT NULL,
  `keywords` text DEFAULT NULL,
  PRIMARY KEY (`mainId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `rating_info`
--

DROP TABLE IF EXISTS `rating_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `rating_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `post_id` int(11) NOT NULL,
  `rating_action` enum('like','dislike') NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_user_post` (`user_id`,`post_id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `recent_removed_models`
--

DROP TABLE IF EXISTS `recent_removed_models`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `recent_removed_models` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `model_id` varchar(255) NOT NULL,
  `removal_date` timestamp NOT NULL DEFAULT current_timestamp(),
  `reason` text DEFAULT NULL,
  `user_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=89 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nickname` varchar(32) NOT NULL,
  `password` varchar(128) NOT NULL,
  `email` varchar(128) NOT NULL DEFAULT '',
  `addedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `viewedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `type` enum('model','member') NOT NULL DEFAULT 'member',
  `attributes` text NOT NULL DEFAULT '',
  `schedule` text NOT NULL DEFAULT '',
  `stats` mediumtext NOT NULL DEFAULT '',
  `social` text NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `nickname` (`nickname`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `usersComments`
--

DROP TABLE IF EXISTS `usersComments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `usersComments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `usersId` int(10) unsigned NOT NULL,
  `modelsId` int(10) unsigned NOT NULL,
  `usersMediaId` int(10) unsigned NOT NULL DEFAULT 0,
  `comment` varchar(256) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `usersSearches`
--

DROP TABLE IF EXISTS `usersSearches`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `usersSearches` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `updatedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `usersId` int(11) NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT 1,
  `url` varchar(256) NOT NULL,
  `keyword` varchar(32) NOT NULL DEFAULT '',
  `age` varchar(8) NOT NULL DEFAULT '',
  `gender` varchar(1) NOT NULL DEFAULT '',
  `category` varchar(16) NOT NULL DEFAULT '',
  `tag` varchar(16) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `usersId_url_idx` (`usersId`,`url`),
  KEY `usersId_idx` (`usersId`)
) ENGINE=InnoDB AUTO_INCREMENT=38 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `usersWebcams`
--

DROP TABLE IF EXISTS `usersWebcams`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `usersWebcams` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `usersId` int(11) NOT NULL,
  `webcamsId` int(11) NOT NULL,
  `notifiedOn` int(11) unsigned NOT NULL,
  `new` tinyint(1) NOT NULL DEFAULT 1,
  PRIMARY KEY (`id`),
  UNIQUE KEY `usersId_webcamsId_idx` (`usersId`,`webcamsId`),
  KEY `usersId_idx` (`usersId`)
) ENGINE=InnoDB AUTO_INCREMENT=20 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `videos`
--

DROP TABLE IF EXISTS `videos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `videos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `processed` tinyint(1) NOT NULL DEFAULT 0,
  `views` smallint(5) unsigned NOT NULL DEFAULT 0,
  `title` varchar(128) DEFAULT NULL,
  `urlTitle` varchar(128) DEFAULT NULL,
  `tags` varchar(256) NOT NULL DEFAULT '',
  `description` varchar(2048) NOT NULL DEFAULT '',
  `origFilename` varchar(128) NOT NULL DEFAULT '',
  `filename` varchar(128) NOT NULL,
  `duration` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `width` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `height` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `aspect_ratio` varchar(8) NOT NULL DEFAULT '16:9',
  `addedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `publishedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `viewedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `mainThumb` smallint(5) unsigned NOT NULL DEFAULT 1,
  `post_date` date DEFAULT NULL,
  `short_description` varchar(255) DEFAULT NULL,
  `categories` varchar(50) DEFAULT NULL,
  `website_model` varchar(50) DEFAULT NULL,
  `post_by` varchar(50) DEFAULT NULL,
  `videokeywords` varchar(255) DEFAULT NULL,
  `meta_title` varchar(128) DEFAULT NULL,
  `meta_description` varchar(2048) DEFAULT NULL,
  `meta_keywords` varchar(255) DEFAULT NULL,
  `meta_video_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `publishedOn_idx` (`publishedOn`)
) ENGINE=InnoDB AUTO_INCREMENT=73 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `videosActions`
--

DROP TABLE IF EXISTS `videosActions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `videosActions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `videosId` int(10) unsigned NOT NULL,
  `action` enum('rename','delete') NOT NULL,
  `info` varchar(128) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=41 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `videosTags`
--

DROP TABLE IF EXISTS `videosTags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `videosTags` (
  `keep` tinyint(1) NOT NULL DEFAULT 1,
  `name` varchar(60) NOT NULL,
  `videosId` int(10) unsigned NOT NULL,
  KEY `name_idx` (`name`),
  KEY `name_webcamsId_idx` (`name`,`videosId`),
  KEY `keep_name_idx` (`keep`,`name`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `webcams`
--

DROP TABLE IF EXISTS `webcams`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `webcams` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `addedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `updatedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `scrapedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `purged` tinyint(1) NOT NULL DEFAULT 0,
  `nickname` varchar(128) NOT NULL,
  `externalId` int(10) unsigned NOT NULL DEFAULT 0,
  `name` varchar(128) NOT NULL,
  `site` enum('cb','sc','bc','ff','sr','lj','sm','so','cs','cr','xc','c4','xl','il','mf','am','fb','sp') DEFAULT NULL,
  `status` enum('o','a','f','g','p') NOT NULL DEFAULT 'o',
  `statusTime` int(11) unsigned NOT NULL DEFAULT 0,
  `subject` varchar(255) NOT NULL DEFAULT '',
  `age` tinyint(3) unsigned NOT NULL DEFAULT 18,
  `birthday` int(10) unsigned NOT NULL DEFAULT 0,
  `imageUrl` varchar(256) NOT NULL DEFAULT '',
  `lastImageTime` int(10) unsigned NOT NULL DEFAULT 0,
  `numImages` smallint(5) unsigned NOT NULL DEFAULT 0,
  `viewers` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `followers` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `gender` enum('c','f','m','t') NOT NULL DEFAULT 'f',
  `hd` tinyint(1) NOT NULL DEFAULT 0,
  `rank` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `genderRank` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `tags` varchar(3070) NOT NULL DEFAULT '',
  `location` varchar(32) NOT NULL DEFAULT '',
  `languages` varchar(128) NOT NULL DEFAULT '',
  `body` varchar(32) NOT NULL DEFAULT '',
  `links` text NOT NULL DEFAULT '',
  `neededForGoal` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `earnedForGoal` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `broadcastVR` tinyint(1) NOT NULL DEFAULT 0,
  `about` varchar(256) NOT NULL DEFAULT '',
  `privateprice` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `privatemin` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `spyprivate` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `upvotes` tinyint(10) unsigned NOT NULL DEFAULT 0,
  `downvotes` tinyint(10) unsigned NOT NULL DEFAULT 0,
  `maxvotes` tinyint(10) unsigned NOT NULL DEFAULT 0,
  `level` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `levelprogress` tinyint(3) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `nickname_site_idx` (`nickname`,`site`),
  KEY `statusTime_site_idx` (`statusTime`,`site`),
  KEY `site_lastImageTime` (`site`,`lastImageTime`),
  KEY `site_idx` (`site`),
  KEY `site_status_idx` (`site`,`status`),
  KEY `status_site_id` (`status`,`site`),
  KEY `tags_idx` (`tags`(767)),
  KEY `status_tags_idx` (`status`,`tags`(767)),
  KEY `status_site_rank_idx` (`status`,`site`,`rank`),
  KEY `status_site_rank_id_idx` (`status`,`site`,`rank`,`id`),
  KEY `status_idx` (`status`),
  KEY `scrapedOn_site_idx` (`scrapedOn`,`site`),
  KEY `name_nickname_subject_tags_idx` (`name`,`nickname`,`subject`,`tags`(767)),
  KEY `idx_site` (`site`)
) ENGINE=InnoDB AUTO_INCREMENT=15297379 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `webcamsArchive`
--

DROP TABLE IF EXISTS `webcamsArchive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `webcamsArchive` (
  `id` int(11) NOT NULL,
  `addedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `updatedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `scrapedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `purged` tinyint(1) NOT NULL DEFAULT 0,
  `nickname` varchar(128) NOT NULL,
  `externalId` int(10) unsigned NOT NULL DEFAULT 0,
  `name` varchar(128) NOT NULL,
  `site` enum('cb','sc','bc','ff','sr','lj','sm','so','cs','cr','xc','c4','xl','il','mf','am','fb','sp') DEFAULT NULL,
  `status` enum('o','a','f','g','p') NOT NULL DEFAULT 'o',
  `statusTime` int(11) unsigned NOT NULL DEFAULT 0,
  `subject` varchar(255) NOT NULL DEFAULT '',
  `age` tinyint(3) unsigned NOT NULL DEFAULT 18,
  `birthday` int(10) unsigned NOT NULL DEFAULT 0,
  `imageUrl` varchar(256) NOT NULL DEFAULT '',
  `lastImageTime` int(10) unsigned NOT NULL DEFAULT 0,
  `numImages` smallint(5) unsigned NOT NULL DEFAULT 0,
  `viewers` smallint(5) unsigned NOT NULL DEFAULT 0,
  `followers` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `gender` enum('c','f','m','t') NOT NULL DEFAULT 'f',
  `hd` tinyint(1) NOT NULL DEFAULT 0,
  `rank` tinyint(1) NOT NULL DEFAULT 0,
  `tags` varchar(3070) NOT NULL DEFAULT '',
  `location` varchar(32) NOT NULL DEFAULT '',
  `languages` varchar(128) NOT NULL DEFAULT '',
  `body` varchar(32) NOT NULL DEFAULT '',
  `links` text NOT NULL DEFAULT '',
  `neededForGoal` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `earnedForGoal` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `broadcastVR` tinyint(1) NOT NULL DEFAULT 0,
  `about` text DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `nickname_site_idx` (`nickname`,`site`),
  KEY `statusTime_site_idx` (`statusTime`,`site`),
  KEY `site_lastImageTime` (`site`,`lastImageTime`),
  KEY `nickname_site_updatedOn_idx` (`nickname`,`site`,`updatedOn`),
  KEY `name_nickname_subject_tags_idx` (`name`,`nickname`,`subject`,`tags`(767)),
  KEY `idx_site` (`site`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `webcamsCategories`
--

DROP TABLE IF EXISTS `webcamsCategories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `webcamsCategories` (
  `keep` tinyint(1) NOT NULL DEFAULT 1,
  `name` varchar(16) NOT NULL,
  `webcamsId` int(10) unsigned NOT NULL,
  KEY `name_idx` (`name`),
  KEY `name_webcamsId_idx` (`name`,`webcamsId`),
  KEY `keep_name_idx` (`keep`,`name`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `webcamsTags`
--

DROP TABLE IF EXISTS `webcamsTags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8mb4 */;
CREATE TABLE `webcamsTags` (
  `keep` tinyint(1) NOT NULL DEFAULT 1,
  `name` varchar(16) NOT NULL,
  `webcamsId` int(10) unsigned NOT NULL,
  KEY `name_idx` (`name`),
  KEY `name_webcamsId_idx` (`name`,`webcamsId`),
  KEY `keep_name_idx` (`keep`,`name`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;
/*!40101 SET character_set_client = @saved_cs_client */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2025-03-31 13:47:43
