
<style>
 
    /* Search History Container */
    /* Search History Container */
    .history-container {
        width: 90%;

        background: white;
        padding: 20px;
        border-radius: 10px;
        box-shadow: 0px 4px 8px rgba(0, 0, 0, 0.1);
    }

    /* Title */
    h2 {
        text-align: center;
        color: #333;
    }

    /* List Styling */
    ul {
        list-style-type: none;
        padding: 0;
    }

    .li-map {
        display: flex;
        align-items: center;
        background: #f9f9f9;
        margin: 10px 0;
        padding: 12px;
        border-radius: 8px;
        transition: 0.3s ease-in-out;
    }

    .li-map:hover {
        background: #e8f0fe;
        transform: scale(1.02);
        transition: 0.3s;
    }

    /* Icons */
    .icon {
        font-size: 20px;
        color: #007bff;
        margin-right: 10px;
    }

    /* Search Link */
    .link-map {
        text-decoration: none;
        color: #007bff;
        font-weight: bold;
        flex-grow: 1;
        display: flex;
        flex-direction: column;
    }

  

    /* Name & Title Formatting */
   

    .search-title {
        font-size: 14px;
        color: #666;
    }

    /* Timestamp */
    .timestamp {
        font-size: 12px;
        color: #888;
        margin-left: auto;
    }

    /* Responsive Design */
    @media (max-width: 480px) {
        li {
            flex-direction: column;
            align-items: flex-start;
            padding: 10px;
        }
        
        .timestamp {
            margin-left: 0;
            margin-top: 5px;
        }
    }


    .search-name {
    font-weight: bold;
    font-size: 18px;
    color: #ff6600; /* Warm color */
    text-shadow: 1px 1px 5px rgba(255, 102, 0, 0.3); /* Soft glow effect */
    transition: color 0.3s ease-in-out;
}

.search-name:hover {
    color: #e65c00; /* Slightly darker on hover */
}



.search-name {
    font-weight: bold;
    font-size: 18px;
    color: #ff4500;
    text-transform: uppercase;
    animation: pulse 1.5s infinite;
}

.space-me-out{
    text-align: center;
    font-weight: 900;
    margin-bottom: 35px;
}
</style>




<div class="history-container">
    <h2>🔍 History of Your Searches</h2>
    <h3 class="space-me-out">Explore and manage your recent search history.</h3>
    <p class="space-me-out">Track your favorite performers and shows. Quickly revisit the content you loved, refine your preferences, and find the best adult webcam experiences.</p>
    <ul>
        <?php 
      

        function timeAgo($timestamp) {
            $current_time = time();
            $time_difference = $current_time - $timestamp;

            if ($time_difference < 60) {
                return "$time_difference sec ago";
            } elseif ($time_difference < 3600) {
                return floor($time_difference / 60) . " min ago";
            } elseif ($time_difference < 86400) {
                return floor($time_difference / 3600) . " hours ago";
            } else {
                return floor($time_difference / 86400) . " days ago";
            }
        }


        foreach ($searches as $s): 
            $formattedTime = date("H:i", $s['updatedOn']); // Format time HH:MM
            $relativeTime = timeAgo($s['updatedOn']); // Get "X min ago"
        ?>


           <li class="li-map">
    <i class="icon fa fa-search"></i> <!-- Search Icon -->
    <a class="link-map" href="<?= htmlspecialchars($s['url']) ?>" target="_blank">
        <span class="search-name">
            <i class="fa fa-video"></i> <?= htmlspecialchars($s['name']) ?>
        </span>
        <span class="search-title"><?= htmlspecialchars($s['title']) ?></span>
    </a>
    <span class="timestamp"><?= $formattedTime ?> (<?= $relativeTime ?>)</span> <!-- Time Display -->
</li>
        <?php endforeach; ?>
    </ul>
</div>

<!-- Font Awesome for Icons -->
 


